Index: EcnlProtoTool/trunk/prototool/src/mrdb.h
===================================================================
--- EcnlProtoTool/trunk/prototool/src/mrdb.h	(revision 438)
+++ EcnlProtoTool/trunk/prototool/src/mrdb.h	(revision 439)
@@ -7,7 +7,11 @@
 #define MRDB_H
 
-#include "mruby.h"
+#include <mruby.h>
 
 #include "mrdbconf.h"
+
+#ifdef _MSC_VER
+# define __func__ __FUNCTION__
+#endif
 
 #define MAX_COMMAND_WORD (16)
@@ -20,4 +24,5 @@
   DBGCMD_BREAK,
   DBGCMD_INFO_BREAK,
+  DBGCMD_INFO_LOCAL,
   DBGCMD_WATCH,
   DBGCMD_INFO_WATCH,
@@ -52,13 +57,4 @@
   DBG_QUIT,
 } mrdb_exemode;
-
-#ifdef _MSC_VER
-# define __func__ __FUNCTION__
-extern long __stdcall InterlockedExchange(long *dst, long src);
-extern long __stdcall InterlockedCompareExchange(long *dst, long src, long cmp);
-#else
-#define InterlockedExchange(dst, src) do { *(dst) = src; } while(0)
-__inline__ static enum mrdb_exemode InterlockedCompareExchange(enum mrdb_exemode *dst, enum mrdb_exemode src, enum mrdb_exemode cmp) { long prev = *(dst); if (*(dst) == cmp) *(dst) = src; return prev; }
-#endif
 
 typedef enum mrdb_exephase {
@@ -110,5 +106,5 @@
   struct mrb_irep *root_irep;
   struct mrb_irep *irep;
-  mrb_code *pc;
+  const mrb_code *pc;
   mrb_value *regs;
 
@@ -117,9 +113,5 @@
   mrb_callinfo *prvci;
 
-#ifdef _MSC_VER
-  long xm;
-#else
   mrdb_exemode xm;
-#endif
   mrdb_exephase xphase;
   mrdb_brkmode bm;
@@ -161,4 +153,5 @@
 dbgcmd_state dbgcmd_break(mrb_state*, mrdb_state*);
 dbgcmd_state dbgcmd_info_break(mrb_state*, mrdb_state*);
+dbgcmd_state dbgcmd_info_local(mrb_state*, mrdb_state*);
 dbgcmd_state dbgcmd_delete(mrb_state*, mrdb_state*);
 dbgcmd_state dbgcmd_enable(mrb_state*, mrdb_state*);
@@ -168,4 +161,5 @@
 dbgcmd_state dbgcmd_eval(mrb_state*, mrdb_state*);
 /* cmdmisc.c */
+dbgcmd_state dbgcmd_list(mrb_state*, mrdb_state*);
 dbgcmd_state dbgcmd_help(mrb_state*, mrdb_state*);
 dbgcmd_state dbgcmd_quit(mrb_state*, mrdb_state*);
Index: EcnlProtoTool/trunk/prototool/src/mrdbconf.h
===================================================================
--- EcnlProtoTool/trunk/prototool/src/mrdbconf.h	(revision 438)
+++ EcnlProtoTool/trunk/prototool/src/mrdbconf.h	(revision 439)
@@ -6,4 +6,12 @@
 #ifndef MRDBCONF_H
 #define MRDBCONF_H
+
+#ifndef MRB_ENABLE_DEBUG_HOOK
+# error mruby-bin-debugger need 'MRB_ENABLE_DEBUG_HOOK' configuration in your 'build_config.rb'
+#endif
+
+#ifdef MRB_DISABLE_STDIO
+# error mruby-bin-debugger conflicts 'MRB_DISABLE_STDIO' configuration in your 'build_config.rb'
+#endif
 
 /* configuration options: */
Index: EcnlProtoTool/trunk/prototool/src/mruby.c
===================================================================
--- EcnlProtoTool/trunk/prototool/src/mruby.c	(revision 438)
+++ EcnlProtoTool/trunk/prototool/src/mruby.c	(revision 439)
@@ -1,34 +1,36 @@
+#include <mruby.h>
+
+#ifdef MRB_DISABLE_STDIO
+# error mruby-bin-mruby conflicts 'MRB_DISABLE_STDIO' configuration in your 'build_config.rb'
+#endif
+
 #include <stdlib.h>
 #include <string.h>
-
-#include "mruby.h"
-#include "mruby/array.h"
-#include "mruby/compile.h"
-#include "mruby/dump.h"
-#include "mruby/variable.h"
-
-#ifdef MRB_DISABLE_STDIO
-static void
-p(mrb_state *mrb, mrb_value obj)
-{
-	mrb_value val = mrb_inspect(mrb, obj);
-
-	fwrite(RSTRING_PTR(val), RSTRING_LEN(val), 1, stdout);
-	putc('\n', stdout);
-}
-#else
-#define p(mrb,obj) mrb_p(mrb,obj)
-#endif
-
-struct _args
-{
-	FILE *rfp;
-	char* cmdline;
-	mrb_bool fname : 1;
-	mrb_bool mrbfile : 1;
-	mrb_bool check_syntax : 1;
-	mrb_bool verbose : 1;
-	int argc;
-	char** argv;
+#include <mruby/array.h>
+#include <mruby/compile.h>
+#include <mruby/dump.h>
+#include <mruby/variable.h>
+
+struct _args {
+  FILE *rfp;
+  char *cmdline;
+  mrb_bool fname        : 1;
+  mrb_bool mrbfile      : 1;
+  mrb_bool check_syntax : 1;
+  mrb_bool verbose      : 1;
+  mrb_bool version      : 1;
+  mrb_bool debug        : 1;
+  int argc;
+  char **argv;
+  int libc;
+  char **libv;
+};
+
+struct options {
+  int argc;
+  char **argv;
+  char *program;
+  char *opt;
+  char short_opt[2];
 };
 
@@ -36,20 +38,89 @@
 usage(const char *name)
 {
-	static const char *const usage_msg[] = {
-		"switches:",
-		"-b           load and execute RiteBinary (mrb) file",
-		"-c           check syntax only",
-		"-e 'command' one line of script",
-		"-v           print version number, then run in verbose mode",
-		"--verbose    run in verbose mode",
-		"--version    print the version",
-		"--copyright  print the copyright",
-		NULL
-	};
-	const char *const *p = usage_msg;
-
-	printf("Usage: %s [switches] programfile\n", name);
-	while (*p)
-		printf("  %s\n", *p++);
+  static const char *const usage_msg[] = {
+  "switches:",
+  "-b           load and execute RiteBinary (mrb) file",
+  "-c           check syntax only",
+  "-d           set debugging flags (set $DEBUG to true)",
+  "-e 'command' one line of script",
+  "-r library   load the library before executing your script",
+  "-v           print version number, then run in verbose mode",
+  "--verbose    run in verbose mode",
+  "--version    print the version",
+  "--copyright  print the copyright",
+  NULL
+  };
+  const char *const *p = usage_msg;
+
+  printf("Usage: %s [switches] [programfile] [arguments]\n", name);
+  while (*p)
+    printf("  %s\n", *p++);
+}
+
+static void
+options_init(struct options *opts, int argc, char **argv)
+{
+  opts->argc = argc;
+  opts->argv = argv;
+  opts->program = *argv;
+  *opts->short_opt = 0;
+}
+
+static const char *
+options_opt(struct options *opts)
+{
+  /* concatenated short options (e.g. `-cv`) */
+  if (*opts->short_opt && *++opts->opt) {
+   short_opt:
+    opts->short_opt[0] = *opts->opt;
+    opts->short_opt[1] = 0;
+    return opts->short_opt;
+  }
+
+  while (++opts->argv, --opts->argc) {
+    opts->opt = *opts->argv;
+
+    /*  empty         || not start with `-`  || `-` */
+    if (!opts->opt[0] || opts->opt[0] != '-' || !opts->opt[1]) return NULL;
+
+    if (opts->opt[1] == '-') {
+      /* `--` */
+      if (!opts->opt[2]) {
+        ++opts->argv, --opts->argc;
+        return NULL;
+      }
+      /* long option */
+      opts->opt += 2;
+      *opts->short_opt = 0;
+      return opts->opt;
+    }
+    else {
+      /* short option */
+      ++opts->opt;
+      goto short_opt;
+    }
+  }
+  return NULL;
+}
+
+static const char *
+options_arg(struct options *opts)
+{
+  if (*opts->short_opt && opts->opt[1]) {
+    /* concatenated short option and option argument (e.g. `-rLIBRARY`) */
+    *opts->short_opt = 0;
+    return opts->opt + 1;
+  }
+  --opts->argc, ++opts->argv;
+  return opts->argc ? *opts->argv : NULL;
+}
+
+static char *
+dup_arg_item(mrb_state *mrb, const char *item)
+{
+  size_t buflen = strlen(item) + 1;
+  char *buf = (char*)mrb_malloc(mrb, buflen);
+  memcpy(buf, item, buflen);
+  return buf;
 }
 
@@ -57,101 +128,109 @@
 parse_args(mrb_state *mrb, int argc, char **argv, struct _args *args)
 {
-	char **origargv = argv;
-	static const struct _args args_zero = { 0 };
-
-	*args = args_zero;
-
-	for (argc--, argv++; argc > 0; argc--, argv++) {
-		char *item;
-		if (argv[0][0] != '-') break;
-
-		if (strlen(*argv) <= 1) {
-			argc--; argv++;
-			args->rfp = stdin;
-			break;
-		}
-
-		item = argv[0] + 1;
-		switch (*item++) {
-		case 'b':
-			args->mrbfile = TRUE;
-			break;
-		case 'c':
-			args->check_syntax = TRUE;
-			break;
-		case 'e':
-			if (item[0]) {
-				goto append_cmdline;
-			}
-			else if (argc > 1) {
-				argc--; argv++;
-				item = argv[0];
-			append_cmdline:
-				if (!args->cmdline) {
-					size_t buflen;
-					char *buf;
-
-					buflen = strlen(item) + 1;
-					buf = (char *)mrb_malloc(mrb, buflen);
-					memcpy(buf, item, buflen);
-					args->cmdline = buf;
-				}
-				else {
-					size_t cmdlinelen;
-					size_t itemlen;
-
-					cmdlinelen = strlen(args->cmdline);
-					itemlen = strlen(item);
-					args->cmdline =
-						(char *)mrb_realloc(mrb, args->cmdline, cmdlinelen + itemlen + 2);
-					args->cmdline[cmdlinelen] = '\n';
-					memcpy(args->cmdline + cmdlinelen + 1, item, itemlen + 1);
-				}
-			}
-			else {
-				printf("%s: No code specified for -e\n", *origargv);
-				return EXIT_SUCCESS;
-			}
-			break;
-		case 'v':
-			if (!args->verbose) mrb_show_version(mrb);
-			args->verbose = TRUE;
-			break;
-		case '-':
-			if (strcmp((*argv) + 2, "version") == 0) {
-				mrb_show_version(mrb);
-				exit(EXIT_SUCCESS);
-			}
-			else if (strcmp((*argv) + 2, "verbose") == 0) {
-				args->verbose = TRUE;
-				break;
-			}
-			else if (strcmp((*argv) + 2, "copyright") == 0) {
-				mrb_show_copyright(mrb);
-				exit(EXIT_SUCCESS);
-			}
-		default:
-			return EXIT_FAILURE;
-		}
-	}
-
-	if (args->rfp == NULL && args->cmdline == NULL) {
-		if (*argv == NULL) args->rfp = stdin;
-		else {
-			args->rfp = fopen(argv[0], args->mrbfile ? "rb" : "r");
-			if (args->rfp == NULL) {
-				printf("%s: Cannot open program file. (%s)\n", *origargv, *argv);
-				return EXIT_FAILURE;
-			}
-			args->fname = TRUE;
-			args->cmdline = argv[0];
-			argc--; argv++;
-		}
-	}
-	args->argv = (char **)mrb_realloc(mrb, args->argv, sizeof(char*) * (argc + 1));
-	memcpy(args->argv, argv, (argc + 1) * sizeof(char*));
-	args->argc = argc;
-
-	return EXIT_SUCCESS;
+  static const struct _args args_zero = { 0 };
+  struct options opts[1];
+  const char *opt, *item;
+
+  *args = args_zero;
+  options_init(opts, argc, argv);
+  while ((opt = options_opt(opts))) {
+    if (strcmp(opt, "b") == 0) {
+      args->mrbfile = TRUE;
+    }
+    else if (strcmp(opt, "c") == 0) {
+      args->check_syntax = TRUE;
+    }
+    else if (strcmp(opt, "d") == 0) {
+      args->debug = TRUE;
+    }
+    else if (strcmp(opt, "e") == 0) {
+      if ((item = options_arg(opts))) {
+        if (!args->cmdline) {
+          args->cmdline = dup_arg_item(mrb, item);
+        }
+        else {
+          size_t cmdlinelen;
+          size_t itemlen;
+
+          cmdlinelen = strlen(args->cmdline);
+          itemlen = strlen(item);
+          args->cmdline =
+            (char *)mrb_realloc(mrb, args->cmdline, cmdlinelen + itemlen + 2);
+          args->cmdline[cmdlinelen] = '\n';
+          memcpy(args->cmdline + cmdlinelen + 1, item, itemlen + 1);
+        }
+      }
+      else {
+        fprintf(stderr, "%s: No code specified for -e\n", opts->program);
+        return EXIT_FAILURE;
+      }
+    }
+    else if (strcmp(opt, "h") == 0) {
+      usage(opts->program);
+      exit(EXIT_SUCCESS);
+    }
+    else if (strcmp(opt, "r") == 0) {
+      if ((item = options_arg(opts))) {
+        if (args->libc == 0) {
+          args->libv = (char**)mrb_malloc(mrb, sizeof(char*));
+        }
+        else {
+          args->libv = (char**)mrb_realloc(mrb, args->libv, sizeof(char*) * (args->libc + 1));
+        }
+        args->libv[args->libc++] = dup_arg_item(mrb, item);
+      }
+      else {
+        fprintf(stderr, "%s: No library specified for -r\n", opts->program);
+        return EXIT_FAILURE;
+      }
+    }
+    else if (strcmp(opt, "v") == 0) {
+      if (!args->verbose) {
+        mrb_show_version(mrb);
+        args->version = TRUE;
+      }
+      args->verbose = TRUE;
+    }
+    else if (strcmp(opt, "version") == 0) {
+      mrb_show_version(mrb);
+      exit(EXIT_SUCCESS);
+    }
+    else if (strcmp(opt, "verbose") == 0) {
+      args->verbose = TRUE;
+    }
+    else if (strcmp(opt, "copyright") == 0) {
+      mrb_show_copyright(mrb);
+      exit(EXIT_SUCCESS);
+    }
+    else {
+      fprintf(stderr, "%s: invalid option %s%s (-h will show valid options)\n",
+              opts->program, opt[1] ? "--" : "-", opt);
+      return EXIT_FAILURE;
+    }
+  }
+
+  argc = opts->argc; argv = opts->argv;
+  if (args->cmdline == NULL) {
+    if (*argv == NULL) {
+      if (args->version) exit(EXIT_SUCCESS);
+      args->rfp = stdin;
+    }
+    else {
+      args->rfp = strcmp(argv[0], "-") == 0 ?
+        stdin : fopen(argv[0], args->mrbfile ? "rb" : "r");
+      if (args->rfp == NULL) {
+        fprintf(stderr, "%s: Cannot open program file: %s\n", opts->program, argv[0]);
+        return EXIT_FAILURE;
+      }
+      args->fname = TRUE;
+      args->cmdline = argv[0];
+      argc--; argv++;
+    }
+  }
+  args->argv = (char **)mrb_realloc(mrb, args->argv, sizeof(char*) * (argc + 1));
+  memcpy(args->argv, argv, (argc+1) * sizeof(char*));
+  args->argc = argc;
+
+  return EXIT_SUCCESS;
 }
 
@@ -159,10 +238,16 @@
 cleanup(mrb_state *mrb, struct _args *args)
 {
-	if (args->rfp && args->rfp != stdin)
-		fclose(args->rfp);
-	if (!args->fname)
-		mrb_free(mrb, args->cmdline);
-	mrb_free(mrb, args->argv);
-	mrb_close(mrb);
+  if (args->rfp && args->rfp != stdin)
+    fclose(args->rfp);
+  if (!args->fname)
+    mrb_free(mrb, args->cmdline);
+  mrb_free(mrb, args->argv);
+  if (args->libc) {
+    while (args->libc--) {
+      mrb_free(mrb, args->libv[args->libc]);
+    }
+    mrb_free(mrb, args->libv);
+  }
+  mrb_close(mrb);
 }
 
@@ -170,76 +255,101 @@
 mruby_main(int argc, char **argv)
 {
-	mrb_state *mrb = mrb_open();
-	int n = -1;
-	int i;
-	struct _args args;
-	mrb_value ARGV;
-	mrbc_context *c;
-	mrb_value v;
-	mrb_sym zero_sym;
-
-	if (mrb == NULL) {
-		fputs("Invalid mrb_state, exiting mruby\n", stderr);
-		return EXIT_FAILURE;
-	}
-
-	n = parse_args(mrb, argc, argv, &args);
-	if (n == EXIT_FAILURE || (args.cmdline == NULL && args.rfp == NULL)) {
-		cleanup(mrb, &args);
-		usage(argv[0]);
-		return n;
-	}
-	else {
-		int ai = mrb_gc_arena_save(mrb);
-		ARGV = mrb_ary_new_capa(mrb, args.argc);
-		for (i = 0; i < args.argc; i++) {
-			mrb_ary_push(mrb, ARGV, mrb_str_new_cstr(mrb, args.argv[i]));
-		}
-		mrb_define_global_const(mrb, "ARGV", ARGV);
-
-		c = mrbc_context_new(mrb);
-		if (args.verbose)
-			c->dump_result = TRUE;
-		if (args.check_syntax)
-			c->no_exec = TRUE;
-
-		/* Set $0 */
-		zero_sym = mrb_intern_lit(mrb, "$0");
-		if (args.rfp) {
-			const char *cmdline;
-			cmdline = args.cmdline ? args.cmdline : "-";
-			mrbc_filename(mrb, c, cmdline);
-			mrb_gv_set(mrb, zero_sym, mrb_str_new_cstr(mrb, cmdline));
-		}
-		else {
-			mrbc_filename(mrb, c, "-e");
-			mrb_gv_set(mrb, zero_sym, mrb_str_new_lit(mrb, "-e"));
-		}
-
-		/* Load program */
-		if (args.mrbfile) {
-			v = mrb_load_irep_file_cxt(mrb, args.rfp, c);
-		}
-		else if (args.rfp) {
-			v = mrb_load_file_cxt(mrb, args.rfp, c);
-		}
-		else {
-			v = mrb_load_string_cxt(mrb, args.cmdline, c);
-		}
-
-		mrb_gc_arena_restore(mrb, ai);
-		mrbc_context_free(mrb, c);
-		if (mrb->exc) {
-			if (!mrb_undef_p(v)) {
-				mrb_print_error(mrb);
-			}
-			n = -1;
-		}
-		else if (args.check_syntax) {
-			printf("Syntax OK\n");
-		}
-	}
-	cleanup(mrb, &args);
-
-	return n == 0 ? EXIT_SUCCESS : EXIT_FAILURE;
-}
+  mrb_state *mrb = mrb_open();
+  int n = -1;
+  int i;
+  struct _args args;
+  mrb_value ARGV;
+  mrbc_context *c;
+  mrb_value v;
+  mrb_sym zero_sym;
+
+  if (mrb == NULL) {
+    fprintf(stderr, "%s: Invalid mrb_state, exiting mruby\n", *argv);
+    return EXIT_FAILURE;
+  }
+
+  n = parse_args(mrb, argc, argv, &args);
+  if (n == EXIT_FAILURE || (args.cmdline == NULL && args.rfp == NULL)) {
+    cleanup(mrb, &args);
+    return n;
+  }
+  else {
+    int ai = mrb_gc_arena_save(mrb);
+    ARGV = mrb_ary_new_capa(mrb, args.argc);
+    for (i = 0; i < args.argc; i++) {
+      char* utf8 = mrb_utf8_from_locale(args.argv[i], -1);
+      if (utf8) {
+        mrb_ary_push(mrb, ARGV, mrb_str_new_cstr(mrb, utf8));
+        mrb_utf8_free(utf8);
+      }
+    }
+    mrb_define_global_const(mrb, "ARGV", ARGV);
+    mrb_gv_set(mrb, mrb_intern_lit(mrb, "$DEBUG"), mrb_bool_value(args.debug));
+
+    c = mrbc_context_new(mrb);
+    if (args.verbose)
+      c->dump_result = TRUE;
+    if (args.check_syntax)
+      c->no_exec = TRUE;
+
+    /* Set $0 */
+    zero_sym = mrb_intern_lit(mrb, "$0");
+    if (args.rfp) {
+      const char *cmdline;
+      cmdline = args.cmdline ? args.cmdline : "-";
+      mrbc_filename(mrb, c, cmdline);
+      mrb_gv_set(mrb, zero_sym, mrb_str_new_cstr(mrb, cmdline));
+    }
+    else {
+      mrbc_filename(mrb, c, "-e");
+      mrb_gv_set(mrb, zero_sym, mrb_str_new_lit(mrb, "-e"));
+    }
+
+    /* Load libraries */
+    for (i = 0; i < args.libc; i++) {
+      FILE *lfp = fopen(args.libv[i], args.mrbfile ? "rb" : "r");
+      if (lfp == NULL) {
+        fprintf(stderr, "%s: Cannot open library file: %s\n", *argv, args.libv[i]);
+        mrbc_context_free(mrb, c);
+        cleanup(mrb, &args);
+        return EXIT_FAILURE;
+      }
+      if (args.mrbfile) {
+        v = mrb_load_irep_file_cxt(mrb, lfp, c);
+      }
+      else {
+        v = mrb_load_file_cxt(mrb, lfp, c);
+      }
+      fclose(lfp);
+    }
+
+    /* Load program */
+    if (args.mrbfile) {
+      v = mrb_load_irep_file_cxt(mrb, args.rfp, c);
+    }
+    else if (args.rfp) {
+      v = mrb_load_file_cxt(mrb, args.rfp, c);
+    }
+    else {
+      char* utf8 = mrb_utf8_from_locale(args.cmdline, -1);
+      if (!utf8) abort();
+      v = mrb_load_string_cxt(mrb, utf8, c);
+      mrb_utf8_free(utf8);
+    }
+
+    mrb_gc_arena_restore(mrb, ai);
+    mrbc_context_free(mrb, c);
+    if (mrb->exc) {
+      if (!mrb_undef_p(v)) {
+        mrb_print_error(mrb);
+      }
+      n = EXIT_FAILURE;
+    }
+    else if (args.check_syntax) {
+      puts("Syntax OK");
+    }
+  }
+  cleanup(mrb, &args);
+
+  return n;
+}
